BEGIN { 
	FS = "\\";
	maxcause = 0; 
	causes[maxcause] = 0;
	times[maxcause] = 0.0;
	agenttimes[maxcause] = 0.0;
	starttime = 0.0;
	livetime = 0.0;
	talktime = 0.0;
	crnumcount = 0; 
	crcount = 0; 
	mccount = 0; 
	ptcount = 0;
	pterrcount = 0;
	cicount = 0; 
	cfcount = 0; 
	account = 0; 
	tccount = 0;
	lccount = 0;
	latecalls = 0;
	timeout = 0;
	sessioncount = 0;
}

$1 ~ /CI$/ { 
	cicount = cicount + 1;
	/* get the time the call was initiated */
	hour = substr($0, 0, 2);
	hour = hour + 0;
	minute = substr($0, 4, 2);
	minute = minute + 0;
	second = substr($0, 7, 2);
	second = second + 0;
	millisecond = substr($0, 10, 3);
	millisecond = millisecond / 1000;
	thetime = hour * 3600;
	thetime = thetime + (minute * 60);
	thetime = thetime + second;
	thetime = thetime + millisecond;#

	phonenum = "";
	sessionid = "";

	for (i = 1; i <= NF; i++)
	{
		if (substr($i, 1, 2) == "TN")
		{
			phonenum = substr($i, 3);
			break;
		}
	}

	for (i = 1; i <= NF; i++)
	{
		if (substr($i, 1, 2) == "SI")
		{
			sessionid = substr($i, 3);
			break;
		}
	}

	if (sessionid != "")
	{
		phones[sessioncount] = phonenum;
		sessionindices[sessionid] = sessioncount;
		inits[sessioncount] = thetime;
		progress[sessioncount] = thetime;
		initdisp[sessioncount] = substr($1, 1, 12);
		progressdisp[sessioncount] = substr($1, 1, 12);

		sessioncount = sessioncount + 1;
	}
}

$1 ~ /DN$/ { 
	cicount = cicount + 1;
	/* get the time the call was initiated */
	hour = substr($0, 0, 2);
	hour = hour + 0;
	minute = substr($0, 4, 2);
	minute = minute + 0;
	second = substr($0, 7, 2);
	second = second + 0;
	millisecond = substr($0, 10, 3);
	millisecond = millisecond / 1000;
	thetime = hour * 3600;
	thetime = thetime + (minute * 60);
	thetime = thetime + second;
	thetime = thetime + millisecond;

	sessionid = ""
	for (i = 1; i <= NF; i++)
	{
		if (substr($i, 1, 2) == "SI")
		{
			sessionid = substr($i, 3);
			break;
		}
	}

	if (sessionid != "")
	{
		sessionix = sessionindices[sessionid];
		progress[sessionix] = thetime;
		progressdisp[sessionix] = substr($1, 1, 12);
	}

}

$1 ~ /CF$/ {
	cfcount = cfcount + 1;
	/* get the time the call was failed */
	hour = substr($0, 0, 2);
	hour = hour + 0;
	minute = substr($0, 4, 2);
	minute = minute + 0;
	second = substr($0, 7, 2);
	second = second + 0;
	millisecond = substr($0, 10, 3);
	millisecond = millisecond / 1000;
	thetime = hour * 3600;
	thetime = thetime + (minute * 60);
	thetime = thetime + second;
	thetime = thetime + millisecond;

	causecode = 0;
	sessionid = 0;

	for (i = 1; i <= NF; i++)
	{
		if (substr($i, 1, 2) == "CA")
		{
			causecode = substr($i, 3);
			causecode = causecode + 0;
			break;
		}
	}

	for (i = 1; i <= NF; i++)
	{
		if (substr($i, 1, 2) == "SI")
		{
			sessionid = substr($i, 3);
			break;
		}
	}

        if(causecode == 26 && sessionid != "")
        {
		sessionix = sessionindices[sessionid];
		/* time to print, only ones with setup ack and progress > 8 seconds */
		setuptime = progress[sessionix] - inits[sessionix];
		ringtime = thetime - progress[sessionix];
		if ((setuptime >= 0.1) && (ringtime >= 8.0))
		{
			printf"%23s %15s %6.3f %6.3f %s %s %s\n", sessionid, phones[sessionix], setuptime, ringtime, initdisp[sessionix], progressdisp[sessionix], substr($1, 1, 12);
		}
	}
	/* only count complete cycles */
	if (starttime != 0)
	{
		causes[causecode] = causes[causecode] + 1;
		times[causecode] = times[causecode] + thetime;
	}
}

END {
}
